Package org.wso2.carbon.registry.admin.api.governance

# Interface IChecklistLifecycleService<LifecycleBean>

Type Parameters:
  `LifecycleBean` - a bean representing a lifecycle definition available for a given resource. This can be used to manage the lifecycle of the given resource, or check on the available lifecycle actions or list the various properties available.

public interface IChecklistLifecycleService<LifecycleBean>
This provides functionality to manage a check-list of a given lifecycle which is available for a particular resource or collection, with the corresponding lifecycle.
Statistics:

- addAspect
- removeAspect
- invokeAspect
- invokeAspectWithParams

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addAspect(String path, String aspect)`
  Method to add the named aspect to the given resource path.
  `LifecycleBean`
  `getLifecycleBean(String path)`
  Method to obtain the lifecycle bean for the given resource path.
  `void`
  `invokeAspect(String path, String aspect, String action, String[] items)`
  Method to invoke an action of the defined aspect at the given resource (or collection) path.
  `void`
  `invokeAspectWithParams(String path, String aspect, String action, String[] items, String[][] params)`
  Method to invoke an action of the defined aspect at the given resource (or collection) path.
  `void`
  `removeAspect(String path, String aspect)`
  Method to remove the named aspect from the given resource path.

- ## Method Details

  - ### getLifecycleBean

    LifecycleBean getLifecycleBean(String path) throws Exception
    Method to obtain the lifecycle bean for the given resource path.
    Parameters:
      `path` - the resource path.
    Returns:
      the lifecycle bean for the given resource path.
    Throws:
      `Exception` - if the operation failed.

  - ### addAspect

    void addAspect(String path, String aspect) throws Exception
    Method to add the named aspect to the given resource path.
    Parameters:
      `path` - the resource path.
      `aspect` - the name of the aspect to add.
    Throws:
      `Exception` - if the operation failed.

  - ### invokeAspect

    void invokeAspect(String path, String aspect, String action, String[] items) throws Exception
    Method to invoke an action of the defined aspect at the given resource (or collection) path.
    Parameters:
      `path` - the resource (or collection) path.
      `aspect` - the name of the aspect.
      `action` - the action to invoke.
      `items` - the values corresponding to the state of various check-list items. If the first check-list item is checked, the value of the first item on this list would be 'true' or 'false' if it was not. If the second check-list item is checked, the value of the second item on this list would be 'true' or 'false' if it was not. The same applies for the remaining items on this list.
    Throws:
      `Exception` - if the operation failed.

  - ### invokeAspectWithParams

    void invokeAspectWithParams(String path, String aspect, String action, String[] items, String[][] params) throws Exception
    Method to invoke an action of the defined aspect at the given resource (or collection) path.
    Parameters:
      `path` - the resource (or collection) path.
      `aspect` - the name of the aspect.
      `action` - the action to invoke.
      `items` - the values corresponding to the state of various check-list items. If the first check-list item is checked, the value of the first item on this list would be 'true' or 'false' if it was not. If the second check-list item is checked, the value of the second item on this list would be 'true' or 'false' if it was not. The same applies for the remaining items on this list.
      `params` - Additional parameters.
    Throws:
      `Exception` - if the operation failed.

  - ### removeAspect

    void removeAspect(String path, String aspect) throws Exception
    Method to remove the named aspect from the given resource path.
    Parameters:
      `path` - the resource path.
      `aspect` - the name of the aspect to remove.
    Throws:
      `Exception` - if the operation failed.